<center><a href="dlregisvec.c">Actual source code: dlregisvec.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:20:26+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCVEC_DLL</font></strong>

<a name="line3"> 3: </a> #include <A href="../../../../include/petscvec.h.html">petscvec.h</A>
<a name="line4"> 4: </a> #include <A href="../../../../include/petscpf.h.html">petscpf.h</A>



<a name="line16"> 16: </a>const char *NormTypes[] = {<font color="#666666">"1"</font>,<font color="#666666">"2"</font>,<font color="#666666">"FROBENIUS"</font>,<font color="#666666">"INFINITY"</font>,<font color="#666666">"1_AND_2"</font>,<font color="#666666">"<A href="../../../../docs/manualpages/Vec/NormType.html#NormType">NormType</A>"</font>,<font color="#666666">"NORM_"</font>,0};
<a name="line17"> 17: </a><A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>   NormIds[7];  <font color="#B22222">/* map from <A href="../../../../docs/manualpages/Vec/NormType.html#NormType">NormType</A> to IDs used to cache Normvalues */</font>

<a name="line21"> 21: </a><font color="#B22222">/*@C</font>
<a name="line22"> 22: </a><font color="#B22222">  <A href="../../../../docs/manualpages/Vec/VecInitializePackage.html#VecInitializePackage">VecInitializePackage</A> - This function initializes everything in the <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> package. It is called</font>
<a name="line23"> 23: </a><font color="#B22222">  from PetscDLLibraryRegister() when using dynamic libraries, and on the first call to <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>()</font>
<a name="line24"> 24: </a><font color="#B22222">  when using static libraries.</font>

<a name="line26"> 26: </a><font color="#B22222">  Input Parameter:</font>
<a name="line27"> 27: </a><font color="#B22222">  path - The dynamic library path, or <A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A></font>

<a name="line29"> 29: </a><font color="#B22222">  Level: developer</font>

<a name="line31"> 31: </a><font color="#B22222">.keywords: <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>, initialize, package</font>
<a name="line32"> 32: </a><font color="#B22222">.seealso: <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>()</font>
<a name="line33"> 33: </a><font color="#B22222">@*/</font>
<a name="line34"> 34: </a><strong><font color="#4169E1"><a name="VecInitializePackage"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../docs/manualpages/Vec/VecInitializePackage.html#VecInitializePackage">VecInitializePackage</A>(char *path)</font></strong>
<a name="line35"> 35: </a>{
<a name="line36"> 36: </a>  static <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> initialized = <A href="../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line37"> 37: </a>  char              logList[256];
<a name="line38"> 38: </a>  char              *className;
<a name="line39"> 39: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        opt;
<a name="line40"> 40: </a>  <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>    ierr;
<a name="line41"> 41: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          i;

<a name="line44"> 44: </a>  <font color="#4169E1">if</font> (initialized) <font color="#4169E1">return</font>(0);
<a name="line45"> 45: </a>  initialized = <A href="../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line46"> 46: </a>  <font color="#B22222">/* Register Classes */</font>
<a name="line47"> 47: </a>  <A href="../../../../docs/manualpages/Profiling/PetscLogClassRegister.html#PetscLogClassRegister">PetscLogClassRegister</A>(&amp;IS_COOKIE,          <font color="#666666">"Index Set"</font>);
<a name="line48"> 48: </a>  <A href="../../../../docs/manualpages/Profiling/PetscLogClassRegister.html#PetscLogClassRegister">PetscLogClassRegister</A>(&amp;VEC_COOKIE,         <font color="#666666">"<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>"</font>);
<a name="line49"> 49: </a>  <A href="../../../../docs/manualpages/Profiling/PetscLogClassRegister.html#PetscLogClassRegister">PetscLogClassRegister</A>(&amp;VEC_SCATTER_COOKIE, <font color="#666666">"<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> Scatter"</font>);
<a name="line50"> 50: </a>  <A href="../../../../docs/manualpages/Profiling/PetscLogClassRegister.html#PetscLogClassRegister">PetscLogClassRegister</A>(&amp;PF_COOKIE,          <font color="#666666">"PointFunction"</font>);
<a name="line51"> 51: </a>  <font color="#B22222">/* Register Constructors */</font>
<a name="line52"> 52: </a>  <A href="../../../../docs/manualpages/Vec/VecRegisterAll.html#VecRegisterAll">VecRegisterAll</A>(path);
<a name="line53"> 53: </a>  <A href="../../../../docs/manualpages/PF/PFRegisterAll.html#PFRegisterAll">PFRegisterAll</A>(path);
<a name="line54"> 54: </a>  <font color="#B22222">/* Register Events */</font>
<a name="line87"> 87: </a>  <font color="#B22222">/* Turn off high traffic events by default */</font>
<a name="line94"> 94: </a>  <font color="#B22222">/* Process info exclusions */</font>
<a name="line95"> 95: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetString.html#PetscOptionsGetString">PetscOptionsGetString</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>, <font color="#666666">"-info_exclude"</font>, logList, 256, &amp;opt);
<a name="line96"> 96: </a>  <font color="#4169E1">if</font> (opt) {
<a name="line97"> 97: </a>    <A href="../../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(logList, <font color="#666666">"is"</font>, &amp;className);
<a name="line98"> 98: </a>    <font color="#4169E1">if</font> (className) {
<a name="line99"> 99: </a>      <A href="../../../../docs/manualpages/Profiling/PetscInfoDeactivateClass.html#PetscInfoDeactivateClass">PetscInfoDeactivateClass</A>(IS_COOKIE);
<a name="line100">100: </a>    }
<a name="line101">101: </a>    <A href="../../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(logList, <font color="#666666">"vec"</font>, &amp;className);
<a name="line102">102: </a>    <font color="#4169E1">if</font> (className) {
<a name="line103">103: </a>      <A href="../../../../docs/manualpages/Profiling/PetscInfoDeactivateClass.html#PetscInfoDeactivateClass">PetscInfoDeactivateClass</A>(VEC_COOKIE);
<a name="line104">104: </a>    }
<a name="line105">105: </a>  }
<a name="line106">106: </a>  <font color="#B22222">/* Process summary exclusions */</font>
<a name="line107">107: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetString.html#PetscOptionsGetString">PetscOptionsGetString</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>, <font color="#666666">"-log_summary_exclude"</font>, logList, 256, &amp;opt);
<a name="line108">108: </a>  <font color="#4169E1">if</font> (opt) {
<a name="line109">109: </a>    <A href="../../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(logList, <font color="#666666">"is"</font>, &amp;className);
<a name="line110">110: </a>    <font color="#4169E1">if</font> (className) {
<a name="line112">112: </a>    }
<a name="line113">113: </a>    <A href="../../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(logList, <font color="#666666">"vec"</font>, &amp;className);
<a name="line114">114: </a>    <font color="#4169E1">if</font> (className) {
<a name="line116">116: </a>    }
<a name="line117">117: </a>  }
<a name="line118">118: </a>  <font color="#B22222">/* Special processing */</font>
<a name="line119">119: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>, <font color="#666666">"-log_sync"</font>, &amp;opt);
<a name="line120">120: </a>  <font color="#4169E1">if</font> (opt) {
<a name="line126">126: </a>  }

<a name="line128">128: </a>  <font color="#B22222">/*</font>
<a name="line129">129: </a><font color="#B22222">         Create the special MPI reduction operation that may be used by <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>/DotBegin()</font>
<a name="line130">130: </a><font color="#B22222">  */</font>
<a name="line131">131: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Op_create.html#MPI_Op_create">MPI_Op_create</A>(PetscSplitReduction_Local,1,&amp;PetscSplitReduction_Op);
<a name="line132">132: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Op_create.html#MPI_Op_create">MPI_Op_create</A>(VecMax_Local,2,&amp;VecMax_Local_Op);
<a name="line133">133: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Op_create.html#MPI_Op_create">MPI_Op_create</A>(VecMin_Local,2,&amp;VecMin_Local_Op);

<a name="line135">135: </a>  <font color="#B22222">/* Register the different norm types for cached norms */</font>
<a name="line136">136: </a>  <font color="#4169E1">for</font> (i=0; i&lt;4; i++) {
<a name="line137">137: </a>    <A href="../../../../docs/manualpages/Sys/PetscObjectComposedDataRegister.html#PetscObjectComposedDataRegister">PetscObjectComposedDataRegister</A>(NormIds+i);
<a name="line138">138: </a>  }
<a name="line139">139: </a>  <font color="#4169E1">return</font>(0);
<a name="line140">140: </a>}

<a name="line142">142: </a><font color="#A020F0">#ifdef PETSC_USE_DYNAMIC_LIBRARIES</font>
<a name="line146">146: </a><font color="#B22222">/*</font>
<a name="line147">147: </a><font color="#B22222">  PetscDLLibraryRegister - This function is called when the dynamic library it is in is opened.</font>

<a name="line149">149: </a><font color="#B22222">  This one registers all the methods that are in the basic PETSc <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> library.</font>

<a name="line151">151: </a><font color="#B22222">  Input Parameter:</font>
<a name="line152">152: </a><font color="#B22222">  path - library path</font>
<a name="line153">153: </a><font color="#B22222"> */</font>
<a name="line154">154: </a><strong><font color="#4169E1"><a name="PetscDLLibraryRegister_petscvec"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PetscDLLibraryRegister_petscvec(char *path)</font></strong>
<a name="line155">155: </a>{

<a name="line158">158: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitializeNoArguments.html#PetscInitializeNoArguments">PetscInitializeNoArguments</A>(); <font color="#4169E1">if</font> (ierr) <font color="#4169E1">return</font> 1;

<a name="line161">161: </a>  <font color="#B22222">/*</font>
<a name="line162">162: </a><font color="#B22222">      If we got here then PETSc was properly loaded</font>
<a name="line163">163: </a><font color="#B22222">  */</font>
<a name="line164">164: </a>  <A href="../../../../docs/manualpages/Vec/VecInitializePackage.html#VecInitializePackage">VecInitializePackage</A>(path);
<a name="line165">165: </a>  <font color="#4169E1">return</font>(0);
<a name="line166">166: </a>}

<a name="line169">169: </a><font color="#A020F0">#endif </font><font color="#B22222">/* PETSC_USE_DYNAMIC_LIBRARIES */</font><font color="#A020F0"></font>
</pre>
</body>

</html>
